-- ********************************************************************************
-- Copyright  Paul Pinault, Disk91 2005-06.
--
-- This program is free software/hardware; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- See : http://www.gnu.org/licenses/gpl.txt
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--
-- Paul Pinault, Disk91 nor Simple-CPU terms can't be used in the way to promote
-- nor legitimate a derived product without the Author authorization.
--
-- =================================================================================
-- Using This software made your own application to become a free-software too
-- considered under GPL. In this case you will have to publish your modificated
-- VHDL code at least on a public website.
-- Perhaps, it's possible to contact the author at ( dpl AT disk91.com ) to obtain
-- the way to have a license spcific distribution of it with or without any fee
-- depending on your project.
-- =================================================================================
--
-- Ce programme est un logiciel / matriel libre, vous pouvez le redistribuer et/ ou
-- le modifier selon les termes de la GNU  General Public License comme publi par
-- la Free Software Fundation ; tablie en version 2 ou suprieure.
--
-- La license en Franais peut tre consultable sur le site suivant :
-- http://fsffrance.org/gpl/gpl-fr.fr.html
--
-- CE PROGRAMME EST FOURNI  TEL QU'EN L'TAT , SANS AUCUNE GARANTIE DE
-- QUELQUE NATURE, IMPLICITE OU EXPLICITE, QUANT  SON UTILISATION
-- COMMERCIALE, PROFESSIONNELLE, LGALE OU NON, OU AUTRE. L'AUTEUR NE PEUT
-- EN AUCUN CAS TRE TENU POUR RESPONSABLE DE QUELQUE DOMMAGE OU PRJUDICE
-- DIRECT, INDIRECT, SECONDAIRE OU ACCESSOIRE DCOULANT DE L'UTILISATION DE
-- TOUT OU PARTIE DE CE PROGRAMME.
--
-- Les noms Paul Pinault, Disk91 ou Simple-CPU ne saurait tre utiliss dans le but
-- de promouvoir ou de lgitimer un produit driv de ce programme sans accord pralable
-- de l'auteur.
-- ********************************************************************************
-- ***************************************************************************************
-- **************************                 M U X                ***********************
-- ***************************************************************************************

   library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.std_logic_arith.all;
   use IEEE.std_logic_unsigned.all;

   entity cl_mux32 is
      port ( SEL  : IN  STD_LOGIC_VECTOR( 4 downto 0 );
             DIN  : IN  STD_LOGIC_VECTOR( (32*32)-1 downto 0 );
             DOUT : OUT STD_LOGIC_VECTOR( 31 downto 0 )
           );
   end cl_mux32;

   -- Un MuxN est constitue de plusieurs Mux en paralleles
   architecture Arch_cl_mux32 of cl_mux32 is
   begin

       DOUT(31 downto 0) <=   DIN( ( 1*32)-1 downto ( 0*32) ) when SEL = "00000" else
                              DIN( ( 2*32)-1 downto ( 1*32) ) when SEL = "00001" else
                              DIN( ( 3*32)-1 downto ( 2*32) ) when SEL = "00010" else
                              DIN( ( 4*32)-1 downto ( 3*32) ) when SEL = "00011" else
                              DIN( ( 5*32)-1 downto ( 4*32) ) when SEL = "00100" else
                              DIN( ( 6*32)-1 downto ( 5*32) ) when SEL = "00101" else
                              DIN( ( 7*32)-1 downto ( 6*32) ) when SEL = "00110" else
                              DIN( ( 8*32)-1 downto ( 7*32) ) when SEL = "00111" else
                              DIN( ( 9*32)-1 downto ( 8*32) ) when SEL = "01000" else
                              DIN( (10*32)-1 downto ( 9*32) ) when SEL = "01001" else
                              DIN( (11*32)-1 downto (10*32) ) when SEL = "01010" else
                              DIN( (12*32)-1 downto (11*32) ) when SEL = "01011" else
                              DIN( (13*32)-1 downto (12*32) ) when SEL = "01100" else
                              DIN( (14*32)-1 downto (13*32) ) when SEL = "01101" else
                              DIN( (15*32)-1 downto (14*32) ) when SEL = "01110" else
                              DIN( (16*32)-1 downto (15*32) ) when SEL = "01111" else
                              DIN( (17*32)-1 downto (16*32) ) when SEL = "10000" else
                              DIN( (18*32)-1 downto (17*32) ) when SEL = "10001" else
                              DIN( (19*32)-1 downto (18*32) ) when SEL = "10010" else
                              DIN( (20*32)-1 downto (19*32) ) when SEL = "10011" else
                              DIN( (21*32)-1 downto (20*32) ) when SEL = "10100" else
                              DIN( (22*32)-1 downto (21*32) ) when SEL = "10101" else
                              DIN( (23*32)-1 downto (22*32) ) when SEL = "10110" else
                              DIN( (24*32)-1 downto (23*32) ) when SEL = "10111" else
                              DIN( (25*32)-1 downto (24*32) ) when SEL = "11000" else
                              DIN( (26*32)-1 downto (25*32) ) when SEL = "11001" else
                              DIN( (27*32)-1 downto (26*32) ) when SEL = "11010" else
                              DIN( (28*32)-1 downto (27*32) ) when SEL = "11011" else
                              DIN( (29*32)-1 downto (28*32) ) when SEL = "11100" else
                              DIN( (30*32)-1 downto (29*32) ) when SEL = "11101" else
                              DIN( (31*32)-1 downto (30*32) ) when SEL = "11110" else
                              DIN( (32*32)-1 downto (31*32) );

   end Arch_cl_mux32;

-- ***************************************************************************************
-- 32 bit decoder ; 5 selection bit width ; copy intput on selected output
   library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.std_logic_arith.all;
   use IEEE.std_logic_unsigned.all;

   entity cl_demux32 is
      port ( SEL  : IN  STD_LOGIC_VECTOR( 4 downto 0 );
             DIN  : IN  STD_LOGIC;
             DOUT : OUT STD_LOGIC_VECTOR( 31 downto 0 )
           );
   end cl_demux32;

   -- Un MuxN est constitue de plusieurs Mux en paralleles
   architecture Arch_cl_demux32 of cl_demux32 is
   begin

      DOUT(0)  <= DIN when ( SEL = "00000" ) else '0';
      DOUT(1)  <= DIN when ( SEL = "00001" ) else '0';
      DOUT(2)  <= DIN when ( SEL = "00010" ) else '0';
      DOUT(3)  <= DIN when ( SEL = "00011" ) else '0';
      DOUT(4)  <= DIN when ( SEL = "00100" ) else '0';
      DOUT(5)  <= DIN when ( SEL = "00101" ) else '0';
      DOUT(6)  <= DIN when ( SEL = "00110" ) else '0';
      DOUT(7)  <= DIN when ( SEL = "00111" ) else '0';
      DOUT(8)  <= DIN when ( SEL = "01000" ) else '0';
      DOUT(9)  <= DIN when ( SEL = "01001" ) else '0';
      DOUT(10) <= DIN when ( SEL = "01010" ) else '0';
      DOUT(11) <= DIN when ( SEL = "01011" ) else '0';
      DOUT(12) <= DIN when ( SEL = "01100" ) else '0';
      DOUT(13) <= DIN when ( SEL = "01101" ) else '0';
      DOUT(14) <= DIN when ( SEL = "01110" ) else '0';
      DOUT(15) <= DIN when ( SEL = "01111" ) else '0';
      DOUT(16) <= DIN when ( SEL = "10000" ) else '0';
      DOUT(17) <= DIN when ( SEL = "10001" ) else '0';
      DOUT(18) <= DIN when ( SEL = "10010" ) else '0';
      DOUT(19) <= DIN when ( SEL = "10011" ) else '0';
      DOUT(20) <= DIN when ( SEL = "10100" ) else '0';
      DOUT(21) <= DIN when ( SEL = "10101" ) else '0';
      DOUT(22) <= DIN when ( SEL = "10110" ) else '0';
      DOUT(23) <= DIN when ( SEL = "10111" ) else '0';
      DOUT(24) <= DIN when ( SEL = "11000" ) else '0';
      DOUT(25) <= DIN when ( SEL = "11001" ) else '0';
      DOUT(26) <= DIN when ( SEL = "11010" ) else '0';
      DOUT(27) <= DIN when ( SEL = "11011" ) else '0';
      DOUT(28) <= DIN when ( SEL = "11100" ) else '0';
      DOUT(29) <= DIN when ( SEL = "11101" ) else '0';
      DOUT(30) <= DIN when ( SEL = "11110" ) else '0';
      DOUT(31) <= DIN when ( SEL = "11111" ) else '0';

   end Arch_cl_demux32;

   -- ***************************************************************************************
   -- 32 bit simple mux

   library IEEE;
   use IEEE.std_logic_1164.all;
   use IEEE.std_logic_arith.all;
   use IEEE.std_logic_unsigned.all;

   entity cl_mux32x1 is
      port ( SEL  : IN  STD_LOGIC_VECTOR( 4 downto 0 );
             DIN  : IN  STD_LOGIC_VECTOR(31 downto 0 );
             DOUT : OUT STD_LOGIC
           );
   end cl_mux32x1;

   -- Un MuxN est constitue de plusieurs Mux en paralleles
   architecture Arch_cl_mux32x1 of cl_mux32x1 is
   begin

       DOUT <=   DIN( 0 ) when SEL = "00000" else
                 DIN( 1 ) when SEL = "00001" else
                 DIN( 2 ) when SEL = "00010" else
                 DIN( 3 ) when SEL = "00011" else
                 DIN( 4 ) when SEL = "00100" else
                 DIN( 5 ) when SEL = "00101" else
                 DIN( 6 ) when SEL = "00110" else
                 DIN( 7 ) when SEL = "00111" else
                 DIN( 8 ) when SEL = "01000" else
                 DIN( 9 ) when SEL = "01001" else
                 DIN( 10 ) when SEL = "01010" else
                 DIN( 11 ) when SEL = "01011" else
                 DIN( 12 ) when SEL = "01100" else
                 DIN( 13 ) when SEL = "01101" else
                 DIN( 14 ) when SEL = "01110" else
                 DIN( 15 ) when SEL = "01111" else
                 DIN( 16 ) when SEL = "10000" else
                 DIN( 17 ) when SEL = "10001" else
                 DIN( 18 ) when SEL = "10010" else
                 DIN( 19 ) when SEL = "10011" else
                 DIN( 20 ) when SEL = "10100" else
                 DIN( 21 ) when SEL = "10101" else
                 DIN( 22 ) when SEL = "10110" else
                 DIN( 23 ) when SEL = "10111" else
                 DIN( 24 ) when SEL = "11000" else
                 DIN( 25 ) when SEL = "11001" else
                 DIN( 26 ) when SEL = "11010" else
                 DIN( 27 ) when SEL = "11011" else
                 DIN( 28 ) when SEL = "11100" else
                 DIN( 29 ) when SEL = "11101" else
                 DIN( 30 ) when SEL = "11110" else
                 DIN( 31 );

   end Arch_cl_mux32x1;
